globals
[
    ratioBrewer
    ratioWholesaler
    ratioRetailer
    userNumbersToNames
    retailers
    brewers
    wholesalers
    day

    brewerPurchaseCost
    brewerSalePrice
    brewerStorageCost

]

breeds
[
    player
]

player-own
[
    myUserId ; the hubnet id that corresponds to this turtle
    ; ordersPlaced ; doesn't seem to be used
    clients ; folks downstream of me
    supplier ; who goves me my beer
    inventory  ; what i have on hand
    ; demand  ; victor, what was this for ?? --rbs
    waitingList ; orders i need to fill
    playerType  ; "retailer", "brewer", "wholesaler"
    lastShipment ; the last shipment i received
    lastWeekDemand ; the demand i saw over the last week
    nextOrder    ; how much to place on my next order
    bankAccount  ;how much money i have
    revenueNotGotten
    breweryList ; used only by brewers
]

to startup
  hubnet-set-client-interface "COMPUTER" [ "clients/Beer Game Alternate 2 client.nlogo" ]
  hubnet-reset
  setup
end


to setup
    set ratioBrewer 1
    set ratioWholesaler 2
    set ratioRetailer 6
    set userNumbersToNames []
    set day 0
    
    set brewerPurchaseCost .25
    set brewerSalePrice .6
    set brewerStorageCost .10
end

to Go
    ;ask player [ sendInfoToClient ]
    advanceClock
    processOrders    
    ask player [ sendInfoToClient ]
    ;ask player [ set lastWeekDemand 0 ]
    wait 2
end

to reset
    set day 0
    ask player
    [
        resetPlayerValues
    ]
end


to advanceClock
    set day day + 1
end

to processOrders
    if (day > 6 ) and (currentDay day  = "Friday") ; the day the supppliers receive new orders
    [
        ask player with [(playerType = "wholesaler") or (playerType = "brewer")]
        [
            set lastWeekDemand 0
        ]
    ]
    if (day > -1 ) and (currentDay day  = "Tuesday") ; the day the supppliers receive new orders
    [
        ask player ;with [(playerType = "wholesaler") or (playerType = "brewer")]
        [
            set lastShipment 0
        ]
    ]
;    if currentDay day = "Saturday" ; the day the Brewers receive new orders
;    [
;        ask player with [playerType = "brewer"]
;        [
;            set lastWeekDemand 0
;        ]
;    ]
    ask player
    [
        pump
    ]
end



to-report RepresentDay [d] ;;convert from a day number to a pretty string
    report (currentDay d) + " of Week " + (currentWeek d)
end

to-report currentDay [d]
    if d mod 7 = 0
    [
        report "Sunday"
    ]
    if d mod 7 = 1
    [
        report "Monday"
    ]
    if d mod 7 = 2
    [
        report "Tuesday"
    ]
    if d mod 7 = 3
    [
        report "Wednesday"
    ]
    if d mod 7 = 4
    [
        report "Thursday"
    ]
    ifelse d mod 7 = 5
    [
        report "Friday"
    ]
    [
        report "Saturday"
    ]
end

to-report currentWeek [d]
    report floor (1 + (d / 7))
end ;reports current week

;;;;;;;;;;;;;;;;;;;
; Player procedures
;;;;;;;;;;;;;;;;;;;
to add-new-client [newclient]
    set clients fput newclient clients
end ;add new client to supplier's list


;;;;;;;;;;;;;
;victor's code of death
;;;;;;;;;;;;;

to chargeForStorage
    set bankAccount (bankAccount - (inventory * roleCoefficient playerType) * brewerStorageCost) ;charge for leftover inventory    
end

to placeOrder [myOrder] ; myOrder = number of units to order
    locals
    [
        tempList
        newOrder
    ]
    ;show myUserId + "lowering account for " + inventory + " times " + roleCoefficient playerType * brewerStorageCost
    ifelse playerType = "brewer"
    [
        without-interruption
        [
            set breweryList lput myOrder breweryList 
        ]
    ]
    [ ; everybody Else
        set newOrder list myUserId myOrder
        ;show "Created a new order: " + newOrder
        ask supplier ;player with [myUserId = supplier-of myself]
        [
            without-interruption
            [
                set tempList lput newOrder first reverse waitingList
                ;set tempList lput (list (myUserId-of myself) myOrder) (first (reverse waitingList))
                set waitingList replace-item ( (length waitingList) - 1)  waitingList tempList
                ;set waitingList reverse (fput tempList (butfirst reverse waitingList))
                set lastWeekDemand lastWeekDemand + myOrder ;update what will be the suppliers demand
            ]
            ;sendInfoToClient
        ]
    ]
end 


to pump
    ;    Place        Receive
    ;R    Fri        Tue
    ;W    Fri        Tue
    ;B    Fri        Tue        
    
    if currentDay day = "Tuesday"
    [
        chargeForStorage
    ]
     
    if playerType = "retailer"
    [
        ifelse (inventory > 0) and (consumerDemand > 0)
        [
            ifelse (consumerDemand < inventory)
            [
                set bankAccount (bankAccount + (4 * brewerSalePrice * consumerDemand))
                set inventory (inventory - consumerDemand)
            ]
            [
                if (consumerDemand > inventory)
                [
                    set bankAccount (bankAccount + (4 * brewerSalePrice * inventory))
                    set revenueNotGotten revenueNotGotten + (4 * brewerSalePrice * abs (consumerDemand - inventory))
                    set inventory 0
                ]
            ]    
        ]
        [ ;else
            if inventory = 0
            [
                set revenueNotGotten revenueNotGotten + (4 * brewerSalePrice * (consumerDemand))
            ]
        ]
;        ifelse ((inventory - consumerDemand) >= 0)
;        [
;            set inventory (inventory - consumerDemand)
;            
;        ]
;        [
;            
;            set inventory 0
;        ]
                   
                                
        if currentDay day = "Friday"
        [
            placeOrder nextOrder
        ]
    ]
    if playerType = "wholesaler"
    [
        if currentDay day = "Tuesday"
        [
            supplyDownstream
        ]
        if currentDay day = "Friday"
        [
            placeOrder nextOrder
        ]
    ]
    if playerType = "brewer"
    [
        if currentDay day = "Tuesday"
        [
            without-interruption
            [
                set inventory inventory + first breweryList
                set lastShipment first breweryList
                set bankAccount (bankAccount - first breweryList * brewerPurchaseCost)
                set breweryList butfirst breweryList
            ]
        ]
        if currentDay day = "Tuesday"
        [
            supplyDownstream
        ]
        if currentDay day = "Friday"
        [
            placeOrder nextOrder
        ]
    ]
end  
    
to-report roleCoefficient [role]
    if role = "brewer"
    [
        report 1
    ]
    if role = "wholesaler"
    [
        report 2
    ]
    if role = "retailer"
    [
        report 4
    ]
end


to supplyDownstream
    locals 
    [
        thisWeek
        keepLooping
    ]
    ;; pop the first guy off
    without-interruption
    [
        set thisWeek first waitingList
        set waitingList lput [] butfirst waitingList
    ]
    set keepLooping true
    ;; go through the shit from this week
    while [keepLooping = true]
    [
        if inventory = 0
        [
            set keepLooping  false
        ]
        ifelse everybodyFilled? thisWeek
        [
            set keepLooping  false
        ]
        [
            set thisWeek fillFirstOrder thisWeek
        ]
    ]
    
    if inventory = 0 ; push stuff into being due next week
    [
        set waitingList replace-item 0 waitingList mergeWeeks (reverse thisWeek) first waitingList 
    ]
    
    
    
end

to-report mergeWeeks [leftWeek rightWeek] ;;returns the result of merging the two weeks passed as params. I guess netlogo doesn't have some sort of list merging operator...
    ifelse length leftWeek = 0
    [
        report rightWeek
    ]
    [
        report mergeWeeks butfirst leftWeek fput first leftWeek rightWeek
    ]

end

to-report fillFirstOrder [openWeek] ;;allocates one unit from inventory to the first open order, removes empty orders from this weeks queue
    locals
    [
        toWhom
        newOrder
        newAmount
    ]
    
    if inventory < 1
    [
        report openWeek
    ]
    
    if length openWeek = 0
    [
        report []
    ]
    
    if not is-number? (first butfirst first openWeek)
    [
        show "openWeek: " + openWeek
        show 3 / 0
    ]
    
    ifelse ((first butfirst first openWeek) < 1) ;; in other words, this order has been filled
    [
        report fillFirstOrder butfirst openWeek
    ]
    [
        set toWhom first first openWeek
        ;;increase the recipient's inventory by one
        without-interruption
        [
            ask player with [myUserId = toWhom]
            [
                set inventory inventory + 1
                set bankAccount (bankAccount - roleCoefficient playerType * brewerPurchaseCost) ;charge the client for the one beer
                set lastShipment lastShipment + 1
            ]
            set inventory inventory - 1
            set bankAccount (bankAccount + roleCoefficient playerType * brewerSalePrice) ;add money to my account
            set newAmount ( ( first butfirst first openWeek) - 1 )
            set newOrder list toWhom  newAmount
        ]
        report lput  newOrder   butfirst openWeek
    ]
    
    
end

to-report sumOfOrdersForWeek [aWeek] ;; report the sum of the orders that are due this week

    ifelse (length aWeek) = 0
    [
        report 0
    ]
    [
        report first butfirst first aWeek + sumOfOrdersForWeek butfirst aWeek
    ]

end

to-report everybodyFilled? [orders] ;; report true if all the orders are down to zero
    ifelse 0 = length orders
    [
        report true
    ]
    [
        ifelse 0 = first butfirst first orders
        [
            report everybodyFilled? butfirst orders
        ]
        [
            report false
        ]
    ]
    
end


to initializePlayer [newUserId newPlayerType newSupplier newInventory]
        show newUserId + " has supplier " +  newSupplier + " inv = " + newInventory
        set myUserId newUserId
        set clients []
        set supplier newSupplier
        set inventory newInventory
        ;set demand 0
        set playerType newPlayerType
        resetPlayerValues
        
        if supplier != nobody
        [
            ask supplier
            [
                add-new-client myself
            ]
        ]

end

to resetPlayerValues
    show "resetPlayerValues for " + myUserId
        ifelse (playerType = "retailer")
        [
            set lastWeekDemand consumerDemand * 7 ; ; not used  
            set waitingList [ [] ]
            set inventory startingRetailerInventory
        ];else
        [
            ifelse (playerType = "wholesaler")
            [
                set waitingList [ [] [] [] [] ]
                set lastWeekDemand floor (consumerDemand * 7 * (ratioRetailer / ratioWholesaler))
                set inventory startingWholesalerInventory   
            ]
            [ ;; brewer
                set waitingList [ [] [] [] [] ]
                set lastWeekDemand floor (consumerDemand * 7 * (ratioRetailer / ratioBrewer ) )
                set breweryList (list lastWeekDemand lastWeekDemand )
                set inventory startingBrewerInventory
            ]
        ]
        set lastShipment lastWeekDemand
        set nextOrder lastShipment
        set bankAccount 100
        set revenueNotGotten 0.00        
end

to processMessage [incomingMessage]
    if incomingMessage = "^"
    [
        set nextOrder nextOrder + 7
    ]
    if incomingMessage = "v" and nextOrder > 0
    [
        set nextOrder nextOrder - 7
    ]
    hubnet-send myUserId "Next Order To Place" nextOrder
    ;    sendInfoToClient
end

to sendOneTimeInfo
    hubnet-send myUserId "You are a" playerType
    ifelse playerType = "brewer"
    [
        hubnet-send myUserId "Your Supplier Is" "not applicable"
    ]
    [
        hubnet-send myUserId "Your Supplier Is" myUserId-of supplier  
    ]
    hubnet-send myUserId "Sale Price per Beer" "$" + roleCoefficient playerType * brewerSalePrice + "0"
    ifelse playerType = "brewer" ;to prevent purchase price being $0.250
    [
        hubnet-send myUserId "Purchase Cost per Beer" "$" + roleCoefficient playerType * brewerPurchaseCost
    ]
    [
        hubnet-send myUserId "Purchase Cost per Beer" "$" + roleCoefficient playerType * brewerPurchaseCost + "0"
    ]
    hubnet-send myUserId "Storage Cost per Beer" "$" + roleCoefficient playerType * brewerStorageCost + "0"
end    



to sendInfoToClient 
  hubnet-send myUserId "Inventory On Hand" inventory
  hubnet-send myUserId "Last Incoming Shipment" lastShipment
  ;hubnet-send myUserId "Waiting List" waitingList
  hubnet-send myUserId "Today Is" RepresentDay day
  hubnet-send myUserId "Next Order To Place" nextOrder
  ifelse playerType = "retailer"
  [
      hubnet-send myUserId "Current Downstream Demand" "" + (consumerDemand * 7) + " per week"
  ]
  [
      hubnet-send myUserId "Current Downstream Demand" lastWeekDemand
  ]
  ifelse playerType = "retailer"
  [
      hubnet-send myUserId "Potential Revenue Missed" "$" + precision revenueNotGotten 2 + "0"
      
      hubnet-send myUserId "Requested for delivery this week" "not applicable"
  ]
  [
      hubnet-send myUserId "Potential Revenue Missed" "not applicable"
      hubnet-send myUserId "Requested for delivery this week" sumOfOrdersForWeek first waitingList
  ]
  ifelse day < 2 ;if it's before the first Tuesday, don't show the extra 0
  [
      hubnet-send myUserId "Bank Account" "$" + precision bankAccount 2
  ]
  [
      hubnet-send myUserId "Bank Account" "$" + precision bankAccount 2 + "0"
  ]
end

to BuildAllInitialWaitingLists ; observer
    ask player with [(playerType = "brewer") or (playerType = "wholesaler")]
    [
        buildMyInitialWaitingList
    ]
end

to buildMyInitialWaitingList ; for when we start the game, to be called after everyone has joined
    locals
    [
        doTimes
    ]
    show "building " + myUserId + "'s initial waiting list using: " + waitingList
    set doTimes length waitingList
    set waitingList []
    repeat doTimes
    [
        set waitingList fput makeOneWeekInitialWaitingList waitingList
    ]
    
end

to-report makeOneWeekInitialWaitingList ; player procedure
    locals
    [
        myOutput
        incredibleShrinkingClients
        howMuchToOrder
    ]
    set myOutput []
    set incredibleShrinkingClients clients
    
    
    repeat length clients
    [
;        show "making week with remainder list :  " + incredibleShrinkingClients
        set myOutput fput  (list myUserId-of first incredibleShrinkingClients nextOrder-of first incredibleShrinkingClients  )  myOutput
    
        set incredibleShrinkingClients butfirst incredibleShrinkingClients
    ]
    report    myOutput
end





;;;;;;;;;;;;;;;;;;;;;;;;
;Client-Server Stuff   ;
;;;;;;;;;;;;;;;;;;;;;;;;

to listen-clients
  while [ hubnet-message-waiting? ]
  [
    hubnet-fetch-message
    ifelse hubnet-enter-message?
    [ onUserConnect hubnet-message-source ]
    [
      ifelse hubnet-exit-message?
      [ noOp ]
      [ 
          ask player with [myUserId = hubnet-message-source]
          [
              processMessage hubnet-message-tag
          ]
      ]
    ]
  ]
end
    
            
to onUserConnect [newUserId]
    set userNumbersToNames lput newUserId userNumbersToNames 
    create-custom-player 1
    [
        initializePlayer newUserId 
                         (getRole getUserNumber newUserId)
                         (getBestSupplier getRole getUserNumber newUserId)
                         defaultStartInventory getRole getUserNumber newUserId                         
        sendInfoToClient 
        sendOneTimeInfo
    ]
end



to noOp
end


to-report defaultStartInventory [role]
    ifelse role = "retailer"
    [
        report startingRetailerInventory
    ]
    [
        ifelse role = "wholesaler"
        [
            report startingWholesalerInventory
        ]
        [
            report startingBrewerInventory
        ]
    ]
end;reports starting inventory as read from slider

to-report getBestSupplier [role] ;;used to assign new players their upstream
  
    ifelse role = "retailer"
    [
        report min-one-of (player with [playerType = "wholesaler"]) [length clients]  
    ]
    [
        ifelse role = "wholesaler"
        [
            report min-one-of (player with [playerType = "brewer"]) [length clients] 
        ]
        [
            report nobody
        ]
    ]       
end ;;getBestSupplier

to-report getUserNumber [userId]
    report position userId userNumbersToNames
end

to-report getUserName [userNumber]
    report item userNumber userNumbersToNames
end

to-report getRole [n] ;; get the role of the nTh person to join
                      ;; outputs "brewer", "wholesaler", or "retailer" depending upon what the new user should be  
    locals
    [
        postMod
    ]
    set postMod n mod (ratioBrewer + ratioWholesaler + ratioRetailer) 
    ifelse postMod < ratioBrewer
    [
        report "brewer"
    ]
    [
        ifelse postMod < ratioWholesaler + ratioBrewer
        [
            report "wholesaler"
        ]
        [
            report "retailer"
        ]
    ]
end ;;getRole


; *** NetLogo Model Copyright Notice ***
;
; This activity and associated models and materials was created as part of the projects:
; PARTICIPATORY SIMULATIONS: NETWORK-BASED DESIGN FOR SYSTEMS LEARNING IN CLASSROOMS and 
; INTEGRATED SIMULATION AND MODELING ENVIRONMENT.
; These projects gratefully acknowledge the support of the 
; National Science Foundation (REPP & ROLE programs) -- grant numbers 
; REC #9814682 and REC-0126227.
;
; Copyright 2003 by Uri Wilensky & Walter Stroup. Updated 2003. All rights reserved.
;
; Permission to use, modify or redistribute this model is hereby granted,
; provided that both of the following requirements are followed:
; a) this copyright notice is included.
; b) this model will not be redistributed for profit without permission
;    from the copyright holders.
; Contact the copyright holders for appropriate licenses for redistribution 
; for profit.
;
; To refer to this model in academic publications, please use:
; Wilensky, U. & Stroup, W. (2003).  NetLogo HubNet Beer Game Alternate 2 model.
; http://ccl.northwestern.edu/netlogo/models/HubNetBeerGameAlternate2
; Center for Connected Learning and Computer-Based Modeling,
; Northwestern University, Evanston, IL.
;
; In other publications, please use:
; Copyright 2003 by Uri Wilensky and Walter Stroup.  All rights reserved.  See
; http://ccl.northwestern.edu/netlogo/models/HubNetBeerGameAlternate2
; for terms of use.
;
; *** End of NetLogo Model Copyright Notice ***
@#$#@#$#@
GRAPHICS-WINDOW
502
473
687
679
17
17
5.0
1
10
1
1
1

CC-WINDOW
3
408
491
557
Command Center

BUTTON
314
41
426
74
Go
Go
T
1
T
OBSERVER
T

SLIDER
51
83
252
116
startingBrewerInventory
startingBrewerInventory
0
200
126
1
1
NIL

SLIDER
50
151
251
184
startingRetailerInventory
startingRetailerInventory
0
50
21
1
1
NIL

SLIDER
50
117
251
150
startingWholesalerInventory
startingWholesalerInventory
0
100
63
1
1
NIL

SLIDER
64
195
236
228
ConsumerDemand
ConsumerDemand
0
50
1
1
1
NIL

BUTTON
17
41
88
74
Listen
listen-clients
T
1
T
OBSERVER
T

MONITOR
76
262
214
311
Day
RepresentDay day
3
1

BUTTON
357
97
427
130
Reset
reset
NIL
1
T
OBSERVER
T

BUTTON
108
41
297
74
Ready To Go
buildAllInitialWaitingLists
NIL
1
T
OBSERVER
T

@#$#@#$#@
SPECIAL NOTE
------------
"Beer Game Alternate 1" and "Beer Game Alternate 2" are supplied with this release as examples of other possible approaches to designing and implementing a Beer Game activity.  The main Beer Game activity is the one we have developed most fully in terms of: design; reliability and robustness; documentation; and quality of code.  However, we felt that users might also be interested in seeing these other implementations.  Be cautious if intending to use the alternates with an actual group.


WHAT IS IT?
-----------
This is a HubNet Participatory simulation of the Beer Game. The beer game is a model of a product distribution system. 

Players play as either retailers (who see demand from consumers and order from wholesalers), wholesalers (who see demand from retailers and order from brewers), or brewers (who see demand from wholesalers and produce the beer to give to wholesalers). Players try to maximize their profit, which is derived from selling the most beer possible. Buying beer and keeping it in inventory costs money. Crucial is the fact that beer is not delivered immediately upon order placement; rather, retailers and wholesalers wait an average of four weeks to receive their orders. Wholesalers and brewers maintain a waiting list of orders received but not yet filled. Beer to satisfy this waiting list is alloted as soon as possible.


HOW TO USE IT
-------------
For the administrator, press the Listen button and leave it pressed while participants log onto the simulation.  Once everyone is logged on, click the Ready To Go button.  When you are ready to begin play, click Go and leave it depressed until you wish to end play.

For players, the only actions required while playing the game are increasing and decreasing the size of orders placed each week. The interface tells players what their role is, who their supplier is, and the financial costs and revenues per unit of beer. Orders are sent to the supplier using whatever value is in the Next Order to Place monitor on Friday.  Orders are received on Tuesday.  Inventory costs are assessed on Tuesday also.

The Requested for delivery monitor (only used by wholesalers and brewers) tells users how much beer should be delivered in the current week. For example, if two units were ordered four weeks ago to be delivered this week and two units last week went unfilled, the requested for delivery monitor would indicate four. 


THINGS TO NOTICE
----------------
While playing, players should try to make note of how demand changes over time. This can be useful in analyzing the behavior of the system at the end of the game. 



THINGS TO TRY
-------------
The administrator of the game should initially let consumer demand remain stable. Once players are comfortable with the steady state of the system, the administrator should double or triple consumer demand. Players who are unfamiliar with the emergent dynamics of the system will often greatly exaggerate the change in demand when placing their own orders. Usually, this results in bankrupcy. 


EXTENDING THE MODEL
-------------------
Users could modify the model to change the latencies of the game or to adjust the ratio of retailers to wholesalers to brewers.  Also, try to add an additional role in the system, such as a distributor.  See if this changes the dynamics of the system.


NETLOGO FEATURES
----------------
This model uses NetLogo's HubNet to handle interactions with players. A future version of this model will use NetLogo's nascent  peer-to-peer networking to allow players to customize the information they see during game play, as well as write code to play on their behalf. 


RELATED MODELS
--------------
Tragedy of the Commons


CREDITS AND REFERENCES
----------------------
See Senge's "The Fifth Discipline" for more information about the beer game.

This activity and associated models and materials was created as part of the projects:
PARTICIPATORY SIMULATIONS: NETWORK-BASED DESIGN FOR SYSTEMS LEARNING IN CLASSROOMS and INTEGRATED SIMULATION AND MODELING ENVIRONMENT. These projects gratefully acknowledge the support of the National Science Foundation (REPP & ROLE programs) -- grant numbers REC #9814682 and REC-0126227.

Copyright 2003 by Uri Wilensky & Walter Stroup. All rights reserved. 

Permission to use, modify or redistribute this model is hereby granted, provided that both of the following requirements are followed: 
a) this copyright notice is included. 
b) this model will not be redistributed for profit without permission from the copyright holders. 
Contact the copyright holders for appropriate licenses for redistribution for profit. 

To refer to this model in academic publications, please use: Wilensky, U. & Stroup, W. (2003). NetLogo HubNet Beer Game Alternate 2 model. http://ccl.northwestern.edu/netlogo/models/HubNetBeerGameAlternate2. Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL. 

In other publications, please use: Copyright 2003 by Uri Wilensky and Walter Stroup.  All rights reserved.  See http://ccl.northwestern.edu/netlogo/models/HubNetBeerGameAlternate2 for terms of use.
@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

ant
true
0
Polygon -7566196 true true 136 61 129 46 144 30 119 45 124 60 114 82 97 37 132 10 93 36 111 84 127 105 172 105 189 84 208 35 171 11 202 35 204 37 186 82 177 60 180 44 159 32 170 44 165 60
Polygon -7566196 true true 150 95 135 103 139 117 125 149 137 180 135 196 150 204 166 195 161 180 174 150 158 116 164 102
Polygon -7566196 true true 149 186 128 197 114 232 134 270 149 282 166 270 185 232 171 195 149 186 149 186
Polygon -7566196 true true 225 66 230 107 159 122 161 127 234 111 236 106
Polygon -7566196 true true 78 58 99 116 139 123 137 128 95 119
Polygon -7566196 true true 48 103 90 147 129 147 130 151 86 151
Polygon -7566196 true true 65 224 92 171 134 160 135 164 95 175
Polygon -7566196 true true 235 222 210 170 163 162 161 166 208 174
Polygon -7566196 true true 249 107 211 147 168 147 168 150 213 150

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

bee
true
0
Polygon -256 true false 152 149 77 163 67 195 67 211 74 234 85 252 100 264 116 276 134 286 151 300 167 285 182 278 206 260 220 242 226 218 226 195 222 166
Polygon -16777216 true false 150 149 128 151 114 151 98 145 80 122 80 103 81 83 95 67 117 58 141 54 151 53 177 55 195 66 207 82 211 94 211 116 204 139 189 149 171 152
Polygon -7566196 true true 151 54 119 59 96 60 81 50 78 39 87 25 103 18 115 23 121 13 150 1 180 14 189 23 197 17 210 19 222 30 222 44 212 57 192 58
Polygon -16777216 true false 70 185 74 171 223 172 224 186
Polygon -16777216 true false 67 211 71 226 224 226 225 211 67 211
Polygon -16777216 true false 91 257 106 269 195 269 211 255
Line -1 false 144 100 70 87
Line -1 false 70 87 45 87
Line -1 false 45 86 26 97
Line -1 false 26 96 22 115
Line -1 false 22 115 25 130
Line -1 false 26 131 37 141
Line -1 false 37 141 55 144
Line -1 false 55 143 143 101
Line -1 false 141 100 227 138
Line -1 false 227 138 241 137
Line -1 false 241 137 249 129
Line -1 false 249 129 254 110
Line -1 false 253 108 248 97
Line -1 false 249 95 235 82
Line -1 false 235 82 144 100

bird1
false
0
Polygon -7566196 true true 2 6 2 39 270 298 297 298 299 271 187 160 279 75 276 22 100 67 31 0

bird2
false
0
Polygon -7566196 true true 2 4 33 4 298 270 298 298 272 298 155 184 117 289 61 295 61 105 0 43

boat1
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 33 230 157 182 150 169 151 157 156
Polygon -7566196 true true 149 55 88 143 103 139 111 136 117 139 126 145 130 147 139 147 146 146 149 55

boat2
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 157 54 175 79 174 96 185 102 178 112 194 124 196 131 190 139 192 146 211 151 216 154 157 154
Polygon -7566196 true true 150 74 146 91 139 99 143 114 141 123 137 126 131 129 132 139 142 136 126 142 119 147 148 147

boat3
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 37 172 45 188 59 202 79 217 109 220 130 218 147 204 156 158 156 161 142 170 123 170 102 169 88 165 62
Polygon -7566196 true true 149 66 142 78 139 96 141 111 146 139 148 147 110 147 113 131 118 106 126 71

box
true
0
Polygon -7566196 true true 45 255 255 255 255 45 45 45

butterfly1
true
0
Polygon -16777216 true false 151 76 138 91 138 284 150 296 162 286 162 91
Polygon -7566196 true true 164 106 184 79 205 61 236 48 259 53 279 86 287 119 289 158 278 177 256 182 164 181
Polygon -7566196 true true 136 110 119 82 110 71 85 61 59 48 36 56 17 88 6 115 2 147 15 178 134 178
Polygon -7566196 true true 46 181 28 227 50 255 77 273 112 283 135 274 135 180
Polygon -7566196 true true 165 185 254 184 272 224 255 251 236 267 191 283 164 276
Line -7566196 true 167 47 159 82
Line -7566196 true 136 47 145 81
Circle -7566196 true true 165 45 8
Circle -7566196 true true 134 45 6
Circle -7566196 true true 133 44 7
Circle -7566196 true true 133 43 8

circle
false
0
Circle -7566196 true true 35 35 230

person
false
0
Circle -7566196 true true 155 20 63
Rectangle -7566196 true true 158 79 217 164
Polygon -7566196 true true 158 81 110 129 131 143 158 109 165 110
Polygon -7566196 true true 216 83 267 123 248 143 215 107
Polygon -7566196 true true 167 163 145 234 183 234 183 163
Polygon -7566196 true true 195 163 195 233 227 233 206 159

sheep
false
15
Rectangle -1 true true 90 75 270 225
Circle -1 true true 15 75 150
Rectangle -16777216 true false 81 225 134 286
Rectangle -16777216 true false 180 225 238 285
Circle -16777216 true false 1 88 92

spacecraft
true
0
Polygon -7566196 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135

thin-arrow
true
0
Polygon -7566196 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150

truck-down
false
0
Polygon -7566196 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30
Polygon -8716033 true false 195 75 195 120 240 120 240 75
Polygon -8716033 true false 195 225 195 180 240 180 240 225

truck-left
false
0
Polygon -7566196 true true 120 135 225 135 225 210 75 210 75 165 105 165
Polygon -8716033 true false 90 210 105 225 120 210
Polygon -8716033 true false 180 210 195 225 210 210

truck-right
false
0
Polygon -7566196 true true 180 135 75 135 75 210 225 210 225 165 195 165
Polygon -8716033 true false 210 210 195 225 180 210
Polygon -8716033 true false 120 210 105 225 90 210

turtle
true
0
Polygon -7566196 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105

wolf
false
0
Rectangle -7566196 true true 15 105 105 165
Rectangle -7566196 true true 45 90 105 105
Polygon -7566196 true true 60 90 83 44 104 90
Polygon -16777216 true false 67 90 82 59 97 89
Rectangle -1 true false 48 93 59 105
Rectangle -16777216 true false 51 96 55 101
Rectangle -16777216 true false 0 121 15 135
Rectangle -16777216 true false 15 136 60 151
Polygon -1 true false 15 136 23 149 31 136
Polygon -1 true false 30 151 37 136 43 151
Rectangle -7566196 true true 105 120 263 195
Rectangle -7566196 true true 108 195 259 201
Rectangle -7566196 true true 114 201 252 210
Rectangle -7566196 true true 120 210 243 214
Rectangle -7566196 true true 115 114 255 120
Rectangle -7566196 true true 128 108 248 114
Rectangle -7566196 true true 150 105 225 108
Rectangle -7566196 true true 132 214 155 270
Rectangle -7566196 true true 110 260 132 270
Rectangle -7566196 true true 210 214 232 270
Rectangle -7566196 true true 189 260 210 270
Line -7566196 true 263 127 281 155
Line -7566196 true 281 155 281 192

wolf-left
false
3
Polygon -6524078 true true 117 97 91 74 66 74 60 85 36 85 38 92 44 97 62 97 81 117 84 134 92 147 109 152 136 144 174 144 174 103 143 103 134 97
Polygon -6524078 true true 87 80 79 55 76 79
Polygon -6524078 true true 81 75 70 58 73 82
Polygon -6524078 true true 99 131 76 152 76 163 96 182 104 182 109 173 102 167 99 173 87 159 104 140
Polygon -6524078 true true 107 138 107 186 98 190 99 196 112 196 115 190
Polygon -6524078 true true 116 140 114 189 105 137
Rectangle -6524078 true true 109 150 114 192
Rectangle -6524078 true true 111 143 116 191
Polygon -6524078 true true 168 106 184 98 205 98 218 115 218 137 186 164 196 176 195 194 178 195 178 183 188 183 169 164 173 144
Polygon -6524078 true true 207 140 200 163 206 175 207 192 193 189 192 177 198 176 185 150
Polygon -6524078 true true 214 134 203 168 192 148
Polygon -6524078 true true 204 151 203 176 193 148
Polygon -6524078 true true 207 103 221 98 236 101 243 115 243 128 256 142 239 143 233 133 225 115 214 114

wolf-right
false
3
Polygon -6524078 true true 170 127 200 93 231 93 237 103 262 103 261 113 253 119 231 119 215 143 213 160 208 173 189 187 169 190 154 190 126 180 106 171 72 171 73 126 122 126 144 123 159 123
Polygon -6524078 true true 201 99 214 69 215 99
Polygon -6524078 true true 207 98 223 71 220 101
Polygon -6524078 true true 184 172 189 234 203 238 203 246 187 247 180 239 171 180
Polygon -6524078 true true 197 174 204 220 218 224 219 234 201 232 195 225 179 179
Polygon -6524078 true true 78 167 95 187 95 208 79 220 92 234 98 235 100 249 81 246 76 241 61 212 65 195 52 170 45 150 44 128 55 121 69 121 81 135
Polygon -6524078 true true 48 143 58 141
Polygon -6524078 true true 46 136 68 137
Polygon -6524078 true true 45 129 35 142 37 159 53 192 47 210 62 238 80 237
Line -16777216 false 74 237 59 213
Line -16777216 false 59 213 59 212
Line -16777216 false 58 211 67 192
Polygon -6524078 true true 38 138 66 149
Polygon -6524078 true true 46 128 33 120 21 118 11 123 3 138 5 160 13 178 9 192 0 199 20 196 25 179 24 161 25 148 45 140
Polygon -6524078 true true 67 122 96 126 63 144

@#$#@#$#@
NetLogo 2.0.0
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
