turtles-own
[ new? ]

globals
[
  len
  swirl?
  ball?
  tree1?
  tree2?
  sierpinski?
  koch?
  figureEight?
  first-time-through?
]

to setup
  ca
  crt 1
  ask turtles
  [
    set shape "line"
    set color init-color
    setxy init-x init-y
    set heading 0
    pd
  ]
  set len 64
  set swirl? false
  set ball? false
  set tree1? false
  set tree2? false
  set sierpinski? false
  set koch? false
  set figureEight? false
end

to iterate
  ask turtles
  [
    set new? false
    pd
  ]
  ifelse (swirl?)
  [ swirl ]
  [
    ifelse (ball?)
    [ ball ]
    [
      ifelse (tree1?)
      [ tree1 ]
      [
        ifelse (tree2?)
        [ tree2 ]
        [
          ifelse (sierpinski?)
          [ sierpinskiTree ]
          [
            ifelse (koch?)
            [ kochSnowflake ]
            [
              ifelse (figureEight?)
              [ figureEightCovering ]
              [ applyRules ]
            ]
          ]
        ]
      ]
    ]
  ]
end

;write your own rules for the l-system fractal here.  for commands either read the documentation in this file or 
;follow the directions found in the information file.  briefly,
;    "t" causes every non-new turtle to create a new turtle with the same heading
;    "r <number>" causes every non-new turtle to turn to the right by number degrees
;    "l <number>" causes every non-new turtle to turn to the left by number degrees
;    "ahead <number>" causes every non-new turtle to draw a line of length number in the direction each is heading
;    "f" causes every non-new turtle to draw line of length 1 in the direction each is heading
;    "skip <number>" causes every non-new turtle to move forward by number in the direction each is heading without drawing
;    "s" causes every non-new turtle to move forward by 1 in the direction each is heading without drawing
to applyRules
;enter your rules here
  f f f r 15 t f f f l 30 f f f
;stop entering in rules
end

;hatch a new turtle for all the turtles that are not new to the current iteration and set new? to be true
;further for all those turtles that do create another turtle, change their color by adding to color color-inc
to t
  ask turtles with [not new?] [hatch 1 [set new? true] set color color + color-inc]
end

;turn each turtle that wasn't created during the current iteration to the right by degree degrees
to r [degree]
  ask turtles with [not new?] [rt degree]
end

;turn each turtle that wasn't created during the current iteration to the left by degree degrees
to l [degree]
  ask turtles with [not new?] [lt degree]
end

;move each turtle that wasn't created during the current iteration forward by steps
to ahead [steps]
  ask turtles with [not new?] [fd steps]
end

;move each turtle that wasn't created during the current iteration forward by 1
to f
  ask turtles with [not new?] [fd 1]
end

;move each turtle that wasn't created during the current iteration forward by 1 but do not draw
to s
  ask turtles with [not new?] [pu fd 1 pd]
end

;move each turtle that wasn't created during the current iteration forward by steps but do not draw
to skip [steps]
  ask turtles with [not new?] [pu fd steps pd]
end

;destroys all non-new turtles
to d
  ask turtles with [not new?] [die]
end

;-----------------------------
;        example buttons
;-----------------------------

to swirlSetup
  ca
  crt 1
  set color-inc 9.0
  set init-color 9.0
  ask turtles
  [
    set shape "line"
    set color init-color
    setxy 0 0
    set heading 0
    pd
  ]
  set len 50
  set swirl? true
  set ball? false
  set tree1? false
  set tree2? false
  set sierpinski? false
  set koch? false
  set figureEight? false
end

to swirl
  ask turtles [set new? false pd]
  f f f r 10 t s s s l 60 ahead 5
end

to ballSetup
  ca
  crt 1
  set color-inc 9.0
  set init-color 9.0
  ask turtles
  [
    set shape "line"
    set color init-color
    setxy 0 0
    set heading 0
    pd
  ]
  set len 50
  set swirl? false
  set ball? true
  set tree1? false
  set tree2? false
  set sierpinski? false
  set koch? false
  set figureEight? false
end

to ball
  ask turtles [set new? false pd]
  f f r 45 t s s s l 45 f f f l 45
end

to tree1Setup
  ca
  crt 1
  set color-inc 9.0
  set init-color 9.0
  ask turtles
  [
    set shape "line"
    set color init-color
    setxy 0 -10
    set heading 0
    pd
  ]
  set len 50
  set swirl? false
  set ball? false
  set tree1? true
  set tree2? false
  set sierpinski? false
  set koch? false
  set figureEight? false
end

to tree1
  ask turtles [set new? false pd]
  ahead 4 r 15 ahead 8 t r 180 skip 8 r 180 l 15 ahead 4 l 15 t ahead 8 d
end

to tree2Setup
  ca
  crt 1
  set color-inc 9.0
  set init-color 9.0
  ask turtles
  [
    set shape "line"
    set color init-color 
    setxy 0 -50
    set heading 0
    pd
  ]
  set len 50
  set swirl? false
  set ball? false
  set tree1? false
  set tree2? true
  set sierpinski? false
  set koch? false
  set figureEight? false
end

to tree2
  ask turtles [set new? false pd]
  ahead 10 r 30 ahead 5 t skip -5 l 60 ahead 5 t skip -5 r 30 skip -10
end

to sierpinskiSetup
  ca
  crt 1
  set color-inc 3.0
  set init-color 9.0
  ask turtles
  [
    set shape "line"
    set color init-color
    setxy 0 -25
    set heading 0
    pd
  ]
  set len 55
  set swirl? false
  set ball? false
  set tree1? false
  set tree2? false
  set sierpinski? true
  set koch? false
  set figureEight? false
end

to sierpinskiTree
  ask turtles [set new? false pd]
  repeat 3
  [
    ahead len
    t
    r 180
    skip len
    r 180
    r 120
  ]
  set len (len / 2)
  d
end

to figureEightSetup
  ca
  crt 1
  set color-inc 9.0
  set init-color 9.0
  ask turtles
  [
    set shape "line"
    set color init-color
    setxy 0 0
    set heading 0
    pd
  ]
  set len 50
  set swirl? false
  set ball? false
  set tree1? false
  set tree2? false
  set sierpinski? false
  set koch? false
  set figureEight? true
end

to figureEightCovering
  ask turtles [set new? false pd]
  repeat 4
  [
    ahead len t r 180 skip len l 90
  ]
  set len (len / 2)
  d
end

to kochSetup
  ca
  crt 1
  set color-inc 5.0
  set init-color 9.0
  ask turtles
  [
    set shape "line"
    set color init-color
    setxy -47 -82
    set heading 0
    pd
  ]
  set len 55
  set swirl? false
  set ball? false
  set tree1? false
  set tree2? false
  set sierpinski? false
  set koch? true
  set figureEight? false

  set first-time-through? true
end

to kochSnowflake
  ask turtles [set new? false pd]
  ifelse (first-time-through?)
  [
    set first-time-through? false
    repeat 3  ; we do these rules three times so that we can get the snowflake shape
    [
      t ahead len l 60 t ahead len r 120 t ahead len l 60 t ahead len r 120
    ]
  ]
  [  ; notice these are the same rules as above, except that we only do them once
    t ahead len l 60 t ahead len r 120 t ahead len l 60 t ahead len r 120
  ]

  set len (len / 3)
  d
end


; *** NetLogo Model Copyright Notice ***
;
; This model was created as part of the project:
; PARTICIPATORY SIMULATIONS: NETWORK-BASED DESIGN FOR SYSTEMS LEARNING IN
; CLASSROOMS.  The project gratefully acknowledges the support of the
; National Science Foundation (REPP program) -- grant number REC #9814682.
;
; Copyright 2001 by Uri Wilensky.  Updated 2001.  All rights reserved.
;
; Permission to use, modify or redistribute this model is hereby granted,
; provided that both of the following requirements are followed:
; a) this copyright notice is included.
; b) this model will not be redistributed for profit without permission
;    from Uri Wilensky.
; Contact Uri Wilensky for appropriate licenses for redistribution for
; profit.
;
; To refer to this model in academic publications, please use:
; Wilensky, U. (2001).  NetLogo L-SystemFractals model.
; http://ccl.northwestern.edu/netlogo/models/L-SystemFractals.
; Center for Connected Learning and Computer-Based Modeling,
; Northwestern University, Evanston, IL.
;
; In other publications, please use:
; Copyright 1998 by Uri Wilensky.  All rights reserved.  See
; http://ccl.northwestern.edu/netlogo/models/L-SystemFractals
; for terms of use.
;
; *** End of NetLogo Model Copyright Notice ***
@#$#@#$#@
GRAPHICS-WINDOW
284
17
696
450
100
100
2.0
1
10
1
1
1

CC-WINDOW
290
455
682
616
Command Center

BUTTON
97
50
168
83
Go Once
iterate
NIL
1
T
OBSERVER
T

BUTTON
28
50
83
83
Setup
setup
NIL
1
T
OBSERVER
T

SLIDER
52
118
210
151
color-inc
color-inc
0.0
100.0
9.0
1.0
1
NIL

SLIDER
52
157
213
190
init-color
init-color
0.0
140.0
9.0
1.0
1
NIL

SLIDER
14
193
128
226
init-x
init-x
-100.0
100.0
0.0
1.0
1
NIL

SLIDER
143
192
258
225
init-y
init-y
-100.0
100.0
0.0
1.0
1
NIL

BUTTON
182
50
237
83
Go
iterate
T
1
T
OBSERVER
T

BUTTON
14
388
69
421
Swirl
swirlSetup
NIL
1
T
OBSERVER
T

BUTTON
77
388
132
421
Ball
ballSetup
NIL
1
T
OBSERVER
T

BUTTON
143
388
198
421
Tree1
tree1Setup
NIL
1
T
OBSERVER
T

BUTTON
205
388
260
421
Tree2
tree2Setup
NIL
1
T
OBSERVER
T

BUTTON
14
429
123
465
Sierpinski's Tree
sierpinskiSetup
NIL
1
T
OBSERVER
T

BUTTON
81
476
207
509
Koch's Snowflake
kochSetup
NIL
1
T
OBSERVER
T

BUTTON
133
430
275
466
Figure Eight Covering
figureEightSetup
NIL
1
T
OBSERVER
T

TEXTBOX
4
331
271
382
Examples: Press the buttons to setup examples of L-System Fractals.  Then press the GO or GO ONCE buttons to see them draw.

MONITOR
72
256
198
305
count turtles
count turtles
10
1

@#$#@#$#@
WHAT IS IT?
-----------
This program draws special types of pictures called fractals.  A fractal is a shape that is self-similar - that is, it looks the same no matter how closely you zoom in or out  For instance, a tree can be thought of as a fractal since if you look at the tree as a whole, you see a stick, that is to say the trunk, with branches coming out of it.  Then if you look at a smaller portion of it, say a branch, you see a similar thing, namely, a stick with branches coming out of it.

This model allows you to draw and look at one class of fractals, called L-system fractals.  L-System fractals are made by following a set of rules over and over.  The rules can be few, but a fascinating and complicated fractal can still form.  These rules tell the turtles what to do.  In the beginning, there will be only one turtle for any fractal.  This turtle can do things such as draw a line, or turn to the right or left.  This turtle can also split itself into two turtles. Each new turtle follows the same rules as the original turtle, and draws its own "branch" of the emerging fractal design. 

By using different sets of rules, you can create a wide variety of different fractal designs.


HOW TO USE IT
-------------
Perhaps the best way to start with this program is by looking at examples of some L-system fractals.  In the "Interface" tab, you will find a series of buttons: "Swirl", "Ball", etc.  Each button sets up a different fractal. Some of these examples are famous fractals, such as Sierpinski's tree and Koch's snowflake.  To view these examples, simply click on one of the example buttons and then press the GO button. 

Please be patient while the fractal draws.  Some of these fractals take about 30 seconds to completely draw.  You know that a fractal is done drawing when the button that you clicked, changes back to its original color, a light gray.

You can also have the fractals drawn one step a time.  Once you click an example setup button, instead of clicking the GO button, click on the GO ONCE button.  This draws the fractal by doing the set of rules only one time per click as opposed to continuously, like the GO button.  A final example of a fern or leafy branch can be found by clicking on the SETUP button followed by either the GO ONCE or GO buttons.

If you don't like the location of the fractal on the graphics window you can change it by modifying the value of the following sliders:
The INIT-X slider sets the initial x coordinate of the first turtle.  It changes the horizontal starting location of  the original turtle.
The INIT-Y slider sets the initial y coordinate of the first turtle.  It changes the vertical starting location of  the original turtle.

If you don't like the color scheme of the fractal you can change it by modifying the value of the following sliders:
The INIT-COLOR slider sets the initial color of the first turtle.
The value of the COLOR-INC slider is added to the turtles color anytime a new turtle hatches.

The example buttons and the SETUP button sets up the graphics window to draw a fractal.  Each of the example buttons sets up the graphics window to draw the fractal of the same name.  The SETUP button sets up the graphics window for drawing the rules found in the applyRules procedure in the "Procedures" tab.
 

THINGS TO NOTICE
----------------
Notice the self-similarity of the fractals at each iteration.  What if one were to perform an infinite number of iterations?  Would looking at any piece up close look any different than looking at the whole?  Also notice how the number of turtles in each of the example is multiplied by some number at each iteration.  Does this make sense?  Try to figure out the number of turtles at some arbitrary step n for one or more of the examples.


THINGS TO TRY
-------------
Now that you have played around with settings for the examples provided, why not try making your own fractals.  You can do this by writing a set the following commands in the applyRules function in the "Procedures" tab:
        "t" causes every non-new turtle to create a new turtle with the same heading
        "r <number>" causes every non-new turtle to turn to the right by number degrees
        "l <number>" causes every non-new turtle to turn to the left by number degrees
        "ahead <number>" causes every non-new turtle to draw a line of length number in the direction each is heading
        "f" causes every non-new turtle to draw line of length 1 in the direction each is heading
        "skip <number>" causes every non-new turtle to move forward by number in the direction each is heading without drawing
        "s" causes every non-new turtle to move forward by 1 in the direction each is heading without drawing
        "d" causes all non-new turtles to be destroyed

To make your fractals, you must write a series of these commands into the applyRules function, in between the lines:

;enter your rules here
...
;stop entering in rules

For example, if you wanted to see what kind of a fractal the set of rules 
  ahead 5 t r 45 ahead -2 skip 7 l 30 
would generate, you would just type them into the applyRules procedure as seen below.

to applyRules
;enter your rules here
  ahead 5 t r 45 ahead -2 skip 7 l 30
;stop entering in rules
end

Use the commands above to make your own fractals.  Then change the initial color and color increment values to make the fractal more interesting to look at.  


EXTENDING THE MODEL
-------------------
Try adding switches such as increment-by-random-length or decrement-by-random-degree that could impose a random factor to the movement of the turtles.  Then add to the forward and turning functions, for example, a random value to the number of steps and degrees.  This would increase the realism in a fractal.

Pick up a book on fractals or search on the internet to find fractals that are interesting and try to create them using the rules of L-system fractals.  You may find some resources below.

Try extending the set of rules so that there are more than the basic ones included in this model.  Then use these rules to make new fractals.

Try starting with more than just one turtle, in a different location or heading, and see how that can affect the fractals that you have made.  Does it ruin them or does it make them more interesting and complex?


NETLOGO FEATURES
----------------
Notice the use of agentsets to make some of the commands affect only certain turtles. For example, the reporter WITH is used to isolate non-new turtles and have the rules affect only them.  Also notice how the fractals are formed using several agents following the same rules through the use of the "hatch" primitive, which makes it simple to generate fractals like Sierpinski's tree.


CREDITS AND REFERENCES
----------------------
You may find more information on L-System fractals in the following locations:

This site offers a nice history and explanation of L-system fractals as well as quit a few classic examples of L-systems. 
http://spanky.triumf.ca/www/fractint/LSYS/tutor.html

This site offers an introduction to fractals, including L-system fractals as well as others.
http://www.cs.wpi.edu/~matt/courses/cs563/talks/cbyrd/pres1.html

The Fractal Geometry of Nature by Benoit Mandelbrot

To refer to this model in academic publications, please use: Wilensky, U. (2001).  NetLogo L-System Fractals model. http://ccl.northwestern.edu/netlogo/models/L-SystemFractals. Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.

In other publications, please use: Copyright 2001 by Uri Wilensky.  All rights reserved.  See http://ccl.northwestern.edu/netlogo/models/L-SystemFractals for terms of use.
@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
true
0
Polygon -7566196 true true 45 255 255 255 255 45 45 45

circle
true
0
Circle -7566196 true true 35 35 230

line
true
0
Line -7566196 true 150 0 150 295

person
false
0
Circle -7566196 true true 155 20 63
Rectangle -7566196 true true 158 79 217 164
Polygon -7566196 true true 158 81 110 129 131 143 158 109 165 110
Polygon -7566196 true true 216 83 267 123 248 143 215 107
Polygon -7566196 true true 167 163 145 234 183 234 183 163
Polygon -7566196 true true 195 163 195 233 227 233 206 159

spacecraft
true
0
Polygon -7566196 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135

thin-arrow
true
0
Polygon -7566196 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150

truck-down
false
0
Polygon -7566196 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30
Polygon -8716033 true false 195 75 195 120 240 120 240 75
Polygon -8716033 true false 195 225 195 180 240 180 240 225

truck-left
false
0
Polygon -7566196 true true 120 135 225 135 225 210 75 210 75 165 105 165
Polygon -8716033 true false 90 210 105 225 120 210
Polygon -8716033 true false 180 210 195 225 210 210

truck-right
false
0
Polygon -7566196 true true 180 135 75 135 75 210 225 210 225 165 195 165
Polygon -8716033 true false 210 210 195 225 180 210
Polygon -8716033 true false 120 210 105 225 90 210

turtle
true
0
Polygon -7566196 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105

@#$#@#$#@
NetLogo 2.0beta4
@#$#@#$#@
ballSetup
repeat 14 [ iterate ]
@#$#@#$#@
@#$#@#$#@
